Ext.namespace("dSS", "dSS.config", "dSS.devprops");
dSS.devprops.VisibilityMatrix = {
    'GE' :  {
                'KM:200'    :   { 
                                    'dontcare'      : true, 
                                    'blink'         : true,
                                    'led'           : false, 
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : true
                                },
                'TKM:210'   :  { 
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : true
                                },
                'SDM:200'   :   {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                },
                'KL'        :   {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'threshold'     : true,
                                    'scenetranst'   : false,
                                    'limitedpushbf' : true
                                }
            },
    'GR' :  {
                'KM:200'    :   {
                                    'dontcare:'     : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                },
                'TKM:210'   :   {
                                    'dontcare:'     : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                }
            },
    'RT' :  {
                'TKM:200'    :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                },
                'SDM:200'    :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                }
            }
};

dSS.devprops.GetVisibleProperties = function(devClass, devType, devNumber) {
    var none = {
                   'dontcare'      : false,
                   'blink'         : false,
                   'led'           : false,
                   'transt'        : false,
                   'outmode'       : false,
                   'threshold'     : false,
                   'scenetranst'   : false,
                   'limitedpushbf' : false
               };

    var dc = dSS.devprops.VisibilityMatrix[dSS.config.deviceColors[devClass]];
    if (dc === undefined) {
        throw none;
    }

    var key = dSS.config.deviceTypes[devType];
    if (key !== 'KL') {
        key = key + ':' + devNumber;
    }

    var ret = dc[key];
    if (ret === undefined) {
        throw none;
    } else {
        return ret;
    }
};

